Imports PCBI.Automation
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.IO
Imports System.Windows.Forms

Namespace Demo8CSharp
	Public Class Form1
		Inherits Form

		Private GerberDirectory As String = "C:\Tests\gerberJob"

		Private components As IContainer = Nothing

        Private WithEvents button1 As Button

		Public Sub New()
			Me.InitializeComponent()
		End Sub

        Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
            IAutomation.IAutomationInit()
            Dim mainWindowPCBI As IPCBIWindow = IAutomation.CreateNewPCBIWindow(True)
            Dim pathJob As String = mainWindowPCBI.CreateNewJobDirectory(Me.GerberDirectory)
            mainWindowPCBI.LoadODBJob(pathJob)
            Dim FileNames As List(Of String) = New List(Of String)()
            Dim smallestDiameter As Double = -1.0
            Dim fileOpen As OpenFileDialog = New OpenFileDialog()
            fileOpen.Title = "Select Gerber Fiels"
            fileOpen.Multiselect = True
            If fileOpen.ShowDialog() = DialogResult.OK Then
                Dim fileNames2 As String() = fileOpen.FileNames
                For i As Integer = 0 To fileNames2.Length - 1
                    Dim filePath As String = fileNames2(i)
                    FileNames.Add(filePath)
                Next
                Dim sizeResult As SizeF = Me.LoadGerberFilesAndGetSmallestObjectsSize(fileNames, mainWindowPCBI, smallestDiameter)
                MessageBox.Show(String.Concat(New Object() {"The smallest Item hast:", Environment.NewLine, "Diameter ", smallestDiameter, Environment.NewLine, "Height ", sizeResult.Height, Environment.NewLine, "Width ", sizeResult.Width}), "Restult", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
            End If
        End Sub

        Private Function LoadGerberFilesAndGetSmallestObjectsSize(ByVal FileNames As List(Of String), ByVal parent As IPCBIWindow, ByRef smallestDiameter As Double) As SizeF
            Dim retSize As SizeF = New SizeF(3.40282347E+38F, 3.40282347E+38F)
            Dim [step] As IStep = parent.GetCurrentStep()
            smallestDiameter = 1.7976931348623157E+308
            Dim result As SizeF
            If [step] Is Nothing Then
                result = retSize
            Else
                For Each filename As String In FileNames
                    If File.Exists(filename) Then
                        Dim newGerberName As String = [step].AddGerberLayer(filename, True)
                        Dim layer As ILayer = [step].GetLayer(newGerberName)
                        If layer IsNot Nothing Then
                            If TypeOf layer Is IODBLayer Then
                                Dim gerberLayer As IODBLayer = CType(layer, IODBLayer)
                                For Each gerberItem As IObject In gerberLayer.GetAllLayerObjects()
                                    Dim bounds As RectangleF = gerberItem.GetBounds()
                                    If bounds.Width < retSize.Width Then
                                        retSize.Width = bounds.Width
                                    End If
                                    If bounds.Height < retSize.Height Then
                                        retSize.Height = bounds.Height
                                    End If
                                    Dim spec As IObjectSpecifics = gerberItem.GetSpecifics()
                                    Select Case gerberItem.Type
                                        Case IObjectType.Arc
                                            Dim arc As IArcSpecifics = CType(spec, IArcSpecifics)
                                            If arc.Diameter < smallestDiameter Then
                                                smallestDiameter = arc.Diameter
                                            End If
                                        Case IObjectType.Line
                                            Dim Line As ILineSpecifics = CType(spec, ILineSpecifics)
                                            If Line.Diameter < smallestDiameter Then
                                                smallestDiameter = Line.Diameter
                                            End If
                                    End Select
                                Next
                            End If
                        End If
                    End If
                Next
                result = retSize
            End If
            Return result
        End Function

        Protected Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso Me.components IsNot Nothing Then
                Me.components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private Sub InitializeComponent()
            Me.button1 = New Button()
            MyBase.SuspendLayout()
            Me.button1.Location = New Point(12, 12)
            Me.button1.Name = "button1"
            Me.button1.Size = New Size(260, 86)
            Me.button1.TabIndex = 0
            Me.button1.Text = "Demo 8: find smallest item in gerberfile"
            Me.button1.UseVisualStyleBackColor = True
            MyBase.AutoScaleDimensions = New SizeF(6.0F, 13.0F)
            MyBase.AutoScaleMode = AutoScaleMode.Font
            MyBase.ClientSize = New Size(284, 115)
            MyBase.Controls.Add(Me.button1)
            MyBase.Name = "Form1"
            Me.Text = "Demo 8"
            MyBase.ResumeLayout(False)
        End Sub
    End Class
End Namespace
